# bdm::KalmanCh Class Reference

Kalman filter in square root form. More...

`#include <libKF.h>`

List of all members.

## Public Member Functions
BM * | _copy_ () const
| copy constructor
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const chmat &Q0, const chmat &R0)
| Set parameters with check of relevance.
void | set_statistics (const vec &mu0, const chmat &P0)
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_est (const vec &mu0, const chmat &P0)
| Set estimate values, used e.g. in initialization.
const epdf & | posterior () const
| access function
const enorm< chmat > * | _e () const
mat & | __K ()
| access function
vec | _dP ()
| access function
virtual string | ToString ()
| This method returns a basic info about the current instance.
virtual void | from_setting (const Setting &root)
| This method arrange instance properties according the data stored in the Setting structure.
virtual void | to_setting (Setting &root) const
| This method save all the instance properties into the Setting structure.
Mathematical operations
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs a conditional density 1-step ahead predictor.
Access to attributes
const RV & | _drv () const
void | set_drv (const RV &rv)
void | set_rv (const RV &rv)
double | _ll () const
void | set_evalll (bool evl0)
## Protected Attributes
mat | preA
| pre array (triangular matrix)
mat | postA
| post array (triangular matrix)
RV | rvy
| Indetifier of output rv.
RV | rvu
| Indetifier of exogeneous rv.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
chmat | Q
| Matrix Q in square-root form.
chmat | R
| Matrix R in square-root form.
enorm< chmat > | est
| posterior density on $x_t$
enorm< chmat > | fy
| preditive density on $y_t$
mat | _K
| placeholder for Kalman gain
vec & | _yp
| cache of fy.mu
chmat & | _Ry
| cache of fy.R
vec & | _mu
| cache of est.mu
chmat & | _P
| cache of est.R
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
## Extension to conditional BM
This extension is useful e.g. in Marginalized Particle Filter (bdm::MPF). Alternatively, it can be used for automated connection to DS when the condition is observed
const RV & | _rvc () const
| access function
virtual void | condition (const vec &val)
| Substitute `val` for `rvc`.
RV | rvc
| Name of extension variable.
## Logging of results
virtual void | set_options (const string &opt)
| Set boolean options from a string recognized are: "logbounds,logll".
virtual void | log_add (logger &L, const string &name="")
| Add all logged variables to a logger.
virtual void | logit (logger &L)
ivec | LIDs
| IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll].
ivec | LFlags
| Flags for logging - same size as LIDs, each entry correspond to the same in LIDs.

## Detailed Description

Kalman filter in square root form.

Trivial example:

    #include <estim/libKF.h>
    using namespace bdm;

    // estimation of AR(0) model
    int main() {
            //dimensions
            int dx=3, dy=3, du=1;
            // matrices
            mat A = eye(dx);
            mat B = zeros(dx,du);
            mat C = eye(dx);
            mat D = zeros(dy,du);
            mat Q = eye(dx);
            mat R = 0.1*eye(dy);
            //prior
            mat P0 = 100*eye(dx);
            vec mu0 = zeros(dx);
            // Estimator
            KalmanCh KF;
            KF.set_parameters(A,B,C,D,/*covariances*/ Q,R);
            KF.set_statistics(mu0,P0);
            // Estimation loop
            for (int i=0;i<100;i++){
                    KF.bayes(randn(dx+du));
            }
            //print results
            cout << "Posterior estimate of x is: "  << endl;
            cout << "mean: "<< KF.posterior().mean()<< endl;
            cout << "variance: "<< KF.posterior().variance()<< endl;
    }

## Member Function Documentation

void bdm::KalmanCh::bayes | ( | const vec & | dt | ) | `[virtual]`

Here dt = [yt;ut] of appropriate dimensions.

The following equality hold::

Thus this object evaluates only predictors! Not filtering densities.

Reimplemented from bdm::Kalman< chmat >.

Reimplemented in bdm::EKFCh.

References chmat::_Ch(), bdm::Kalman< chmat >::_K, bdm::Kalman< chmat >::_mu, bdm::Kalman< chmat >::_P, bdm::Kalman< chmat >::_Ry, bdm::Kalman< chmat >::_yp, bdm::Kalman< chmat >::A, bdm::Kalman< chmat >::B, bdm::Kalman< chmat >::C, bdm::Kalman< chmat >::D, bdm::Kalman< chmat >::dimu, bdm::Kalman< chmat >::dimx, bdm::Kalman< chmat >::dimy, bdm::BM::evalll, bdm::eEF::evallog(), bdm::Kalman< chmat >::fy, bdm::BM::ll, postA, and preA.

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following files:

- libKF.h
- libKF.cpp